local DISTARW = 60*FRACUNIT
local MISSTIME = 15
local SINGTIME = 15
local DODGETIME = 15
local ATTACKTIME = 15

/*rawset(_G, "FNF_NoteTypes", {}) //If some one could make Easier the process of making Custom arrows...
FNF_NoteTypes["Default Note"] = 1
FNF_NoteTypes["Hurt Note"] = 6
FNF_NoteTypes["Bullet Note"] = 7
FNF_NoteTypes["Custom Note"] = 2
FNF_NoteTypes["Long Note"] = 5*/

local ARW_DEF = 1
local ARW_HURT = 6 //Special Notes
local ARW_BULLET = 7
local ARW_RING = 3
local ARW_MONITOR = 4
local ARW_ATTACK = 5
//local ARW_HOLD = 5 //Hold note (Unused)
local ARW_CUSTOM = 2 //You can edit this note how you want 

local LEFT = 1 //This is for easier use
local DOWN = 2
local UP = 4
local RIGHT = 3

local HLEFT = 5 //Hurt notes
local HDOWN = 6
local HUP = 8
local HRIGHT = 7 //They kill you if you press them

local BLEFT = 9 //Bullet notes
local BDOWN = 10
local BUP = 12
local BRIGHT = 11 //You should press them or they kill you (Now you can make accelerant lol)

local CLEFT = 21 //Custom notes
local CDOWN = 22
local CUP = 24
local CRIGHT = 23 //This is a custom note that you can customize!

local RLEFT = 13 //Ring notes
local RDOWN = 14
local RUP = 16
local RRIGHT = 15

local MLEFT = 17 //Monitor notes
local MDOWN = 18
local MUP = 20
local MRIGHT = 19

local ALEFT = 25 //Attack notes
local ADOWN = 26
local AUP = 28
local ARIGHT = 27

/*local LLEFT = 13 //Hold notes
local LDOWN = 14
local LUP = 16
local LRIGHT = 15 //Hold them (They are just like normal ones)

local LLEFTE = 17 //Hold note ends
local LDOWNE = 18
local LUPE = 20
local LRIGHTE = 19*/

local dirtocolor = { //Convert Direction to color (Arrow Splashes only use the 1-4 colors)
	[1] = SKINCOLOR_PURPLE, //Normal Arrows
	[2] = SKINCOLOR_BLUE,
	[4] = SKINCOLOR_GREEN,
	[3] = SKINCOLOR_RED,
	
	[5] = SKINCOLOR_RED, //Hurt Arrows
	[6] = SKINCOLOR_RED,
	[8] = SKINCOLOR_RED,
	[7] = SKINCOLOR_RED,
	
	[9] = SKINCOLOR_YELLOW, //Bullet Arrows
	[10] = SKINCOLOR_YELLOW,
	[12] = SKINCOLOR_YELLOW,
	[11] = SKINCOLOR_YELLOW, 
	
	[21] = SKINCOLOR_WHITE, //Custom Arrows
	[22] = SKINCOLOR_SKY,
	[24] = SKINCOLOR_BLUE,
	[23] = SKINCOLOR_BLACK, 
	
	[13] = SKINCOLOR_GOLD, //Ring Arrows
	[14] = SKINCOLOR_GOLD,
	[16] = SKINCOLOR_GOLD,
	[15] = SKINCOLOR_GOLD, 
	
	[17] = SKINCOLOR_GREY, //Monitor Arrows
	[18] = SKINCOLOR_GREY,
	[20] = SKINCOLOR_GREY,
	[19] = SKINCOLOR_GREY, 
	
	[25] = SKINCOLOR_PURPLE, //Attack Arrows
	[26] = SKINCOLOR_CYAN,
	[28] = SKINCOLOR_GREEN,
	[27] = SKINCOLOR_WHITE,
	
	/*[13] = SKINCOLOR_PURPLE, //Hold Arrows
	[14] = SKINCOLOR_BLUE,
	[16] = SKINCOLOR_GREEN,
	[15] = SKINCOLOR_RED,*/
}

local dodgeanims = { //Dodge Anims for Bullet Arrow
	[9] = S_PLAY_SPINDASH,
	[10] = S_PLAY_SPINDASH,
	[12] = S_PLAY_SPINDASH,
	[11] = S_PLAY_SPINDASH, 
	[25] = S_PLAY_SPINDASH,
	[26] = S_PLAY_SPINDASH,
	[28] = S_PLAY_SPINDASH,
	[27] = S_PLAY_SPINDASH
}

local attackanims = { //Attack Anims for Attack Arrow
	[9] = S_PLAY_SPINDASH,
	[10] = S_PLAY_SPINDASH,
	[12] = S_PLAY_SPINDASH,
	[11] = S_PLAY_SPINDASH,
	[25] = S_PLAY_SPINDASH,
	[26] = S_PLAY_SPINDASH,
	[28] = S_PLAY_SPINDASH,
	[27] = S_PLAY_SPINDASH 
}

local singanims = {
	[1] = S_PLAY_WALK,
	[2] = S_PLAY_SPINDASH,
	[4] = S_PLAY_SPRING,
	[3] = S_PLAY_RUN,
}

local missanims = {
	[1] = S_PLAY_WALK,
	[2] = S_PLAY_SPINDASH,
	[4] = S_PLAY_SPRING,
	[3] = S_PLAY_RUN,
}

local dirtostate = { //Convert Direction to state (So notes would be Left, Down, Up, Right)
	[1] = S_ARROW_LEFT, //Normal Arrows
	[2] = S_ARROW_DOWN,
	[4] = S_ARROW_UP,
	[3] = S_ARROW_RIGHT,
	
	[5] = S_ARROW_LEFT_HURT, //Hurt Arrows
	[6] = S_ARROW_DOWN_HURT,
	[8] = S_ARROW_UP_HURT,
	[7] = S_ARROW_RIGHT_HURT,
	
	[9] = S_ARROW_LEFT_BUL, //Bullet Arrows
	[10] = S_ARROW_DOWN_BUL,
	[12] = S_ARROW_UP_BUL,
	[11] = S_ARROW_RIGHT_BUL,
	
	[21] = S_ARROW_LEFT, //Custom Arrows
	[22] = S_ARROW_DOWN_BUL,
	[24] = S_ARROW_UP_HURT,
	[23] = S_ARROW_RIGHT,
	
	[13] = S_ARROW_LEFT_RING, //Ring Arrows
	[14] = S_ARROW_DOWN_RING,
	[16] = S_ARROW_UP_RING,
	[15] = S_ARROW_RIGHT_RING,
	
	[17] = S_ARROW_LEFT_MON, //Monitor Arrows
	[18] = S_ARROW_DOWN_MON,
	[20] = S_ARROW_UP_MON,
	[19] = S_ARROW_RIGHT_MON,
	
	[25] = S_ARROW_LEFT_HURT, //Attack Arrows
	[26] = S_ARROW_DOWN_HURT,
	[28] = S_ARROW_UP_HURT,
	[27] = S_ARROW_RIGHT_HURT,
	
	/*[13] = S_ARROW_HOLD, //Hold Arrows
	[14] = S_ARROW_HOLD,
	[16] = S_ARROW_HOLD,
	[15] = S_ARROW_HOLD,
	
	[17] = S_ARROW_HOLD_END, //Hold end Arrows
	[18] = S_ARROW_HOLD_END,
	[20] = S_ARROW_HOLD_END,
	[19] = S_ARROW_HOLD_END*/
}

local spectodir = { //Add your arrows here
	[1] = 1, //Normal Arrows
	[2] = 2,
	[4] = 4,
	[3] = 3,
	
	[5] = 1, //Hurt Arrows
	[6] = 2,
	[8] = 4,
	[7] = 3,
	
	[9] = 1, //Bullet Arrows
	[10] = 2,
	[12] = 4,
	[11] = 3,
	
	[21] = 1, //Custom Arrows
	[22] = 2,
	[24] = 4,
	[23] = 3,
	
	[13] = 1, //Ring Arrows
	[14] = 2,
	[16] = 4,
	[15] = 3,
	
	[17] = 1, //Monitor Arrows
	[18] = 2,
	[20] = 4,
	[19] = 3,
	
	[25] = 1, //Attack Arrows
	[26] = 2,
	[28] = 4,
	[27] = 3,
}

local splashrandom = {S_ARROW_SPLASH_A1 , S_ARROW_SPLASH_B1}

rawset(_G, "FNF_SpawnArrow", function(mo, dir, speed, arwtype, montype) //Spawn arrows function
	//if mo and mo.valid
		local camangle = R_PointToAngle(mo.x, mo.y)
		local addangle = ANGLE_90*dir
		
		local gotox = FixedMul(DISTARW, cos(camangle+addangle))
		local gotoy = FixedMul(DISTARW, sin(camangle+addangle))
		
		local arrow = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*2, MT_FNF_ARROW)
		arrow.scale = FRACUNIT*2
		arrow.fuse = 150
		arrow.destscale = -1
		arrow.scalespeed = speed
		arrow.color = dirtocolor[dir]
		arrow.flags2 = $|MF2_SPLAT
		arrow.state = dirtostate[dir]
		arrow.appear = 10
		arrow.frame = $|FF_TRANS90
		arrow.target = mo
		arrow.dirarw = dir
		
		if dir >= 1 and dir <= 4
			arrow.arwtype = ARW_DEF
		end
		
		if dir >= 5 and dir <= 8 //This is for easier charting
			arrow.arwtype = ARW_HURT
		end
		
		if dir >= 9  and dir <= 12 //This too
			arrow.arwtype = ARW_BULLET
		end
		
		if dir >= 21  and dir <= 24 //Then beetween which numbers your arrows are for easier charting
			arrow.arwtype = ARW_CUSTOM
		end
		
		if dir >= 13  and dir <= 16
			arrow.arwtype = ARW_RING
		end
		
		if dir >= 17  and dir <= 20
			arrow.arwtype = ARW_MONITOR
		end
		
		if dir >= 25  and dir <= 28
			arrow.arwtype = ARW_ATTACK
		end
		
		
		if arwtype == ARW_DEF
			arrow.arwtype = ARW_DEF
		end
		if arwtype == ARW_BULLET
			arrow.arwtype = ARW_BULLET
		end
		if arwtype == ARW_HURT
			arrow.arwtype = ARW_HURT
		end
		
		if arwtype == ARW_CUSTOM //You add these 3 lines with your arrow
			arrow.arwtype = ARW_CUSTOM
		end
		
		if arwtype == ARW_RING
			arrow.arwtype = ARW_RING
		end
		
		if arwtype == ARW_MONITOR
			arrow.arwtype = ARW_MONITOR
		end
		
		if arwtype == ARW_ATTACK
			arrow.arwtype = ARW_ATTACK
		end
		
		if montype
			arrow.montype = montype
		else
			if P_RandomRange(1, 5) == 1
				arrow.montype = MT_MYSTERY_BOX
			else
				arrow.montype = P_RandomRange(157, 176)
			end
		end
	//end
end)
 
local SICKL = FRACUNIT - FRACUNIT/10
local SICKE = FRACUNIT + FRACUNIT/10

local GOODL = FRACUNIT - (FRACUNIT/10 - FRACUNIT/3)
local GOODE = FRACUNIT + (FRACUNIT/10 + FRACUNIT/3)

local BADL = FRACUNIT - (FRACUNIT/10 - FRACUNIT/4)
local BADE = FRACUNIT + (FRACUNIT/10 + FRACUNIT/6)

local SHITL = FRACUNIT - (FRACUNIT/10 - FRACUNIT/5)
local SHITE = FRACUNIT + (FRACUNIT/10 + FRACUNIT/7)

local LATE =  FRACUNIT - FRACUNIT/5 //Press timings
local EARLY = FRACUNIT + FRACUNIT/3 //Use them by scale because it checks the scale for hitting 

freeslot("sfx_bulnot")               

local numtorate = {
	[1] = S_FNF_SICK,
	[2] = S_FNF_GOOD,
	[3] = S_FNF_BAD,
	[4] = S_FNF_SHIT
}       

local numtocombo = {
	[0] = S_FNF_COMBO_0,
	[1] = S_FNF_COMBO_1,
	[2] = S_FNF_COMBO_2,
	[3] = S_FNF_COMBO_3,
	[4] = S_FNF_COMBO_4,
	[5] = S_FNF_COMBO_5,
	[6] = S_FNF_COMBO_6,
	[7] = S_FNF_COMBO_7,
	[8] = S_FNF_COMBO_8,
	[9] = S_FNF_COMBO_9
}               

rawset(_G, "FNF_Rating", function(mo, rate)
	local camangle = R_PointToAngle(mo.x, mo.y)
	
	local gotox = FixedMul(DISTARW/2, cos(camangle+ANGLE_45))
	local gotoy = FixedMul(DISTARW/2, sin(camangle+ANGLE_45))
	
	local rating = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
	rating.state = numtorate[rate]
	P_SetObjectMomZ(rating, FRACUNIT*2)
	rating.fuse = 15
	P_InstaThrust(rating, camangle + 15*ANG1, FRACUNIT)
end)

local OFFSETDIST = -FRACUNIT*17

rawset(_G, "FNF_SpriteToNum", function(mo, num)
	local camangle = R_PointToAngle(mo.x, mo.y)
	local gotox = FixedMul(DISTARW, cos(camangle-ANGLE_45))
	local gotoy = FixedMul(DISTARW, sin(camangle-ANGLE_45))
	if num and num >= 100
		if num < 200
			local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
			combo.state = S_FNF_COMBO_1
			P_SetObjectMomZ(combo, FRACUNIT*2)
			combo.fuse = 15
			combo.spritexoffset = -OFFSETDIST*2
			P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
		else
			if num < 300
				local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
				combo.state = S_FNF_COMBO_2
				P_SetObjectMomZ(combo, FRACUNIT*2)
				combo.fuse = 15
				combo.spritexoffset = -OFFSETDIST*2
				P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
			else
				if num < 400
					local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
					combo.state = S_FNF_COMBO_3
					P_SetObjectMomZ(combo, FRACUNIT*2)
					combo.fuse = 15
					combo.spritexoffset = -OFFSETDIST*2
					P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
				else
					if num < 500
						local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
						combo.state = S_FNF_COMBO_4
						P_SetObjectMomZ(combo, FRACUNIT*2)
						combo.fuse = 15
						combo.spritexoffset = -OFFSETDIST*2
						P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
					else
						if num < 600
							local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
							combo.state = S_FNF_COMBO_5
							P_SetObjectMomZ(combo, FRACUNIT*2)
							combo.fuse = 15
							combo.spritexoffset = -OFFSETDIST*2
							P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
						else
							if num < 700
								local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
								combo.state = S_FNF_COMBO_6
								P_SetObjectMomZ(combo, FRACUNIT*2)
								combo.fuse = 15
								combo.spritexoffset = -OFFSETDIST*2
								P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
							else
								if num < 800
									local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
									combo.state = S_FNF_COMBO_7
									P_SetObjectMomZ(combo, FRACUNIT*2)
									combo.fuse = 15
									combo.spritexoffset = -OFFSETDIST*2
									P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
								else
									if num < 900
										local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
										combo.state = S_FNF_COMBO_8
										P_SetObjectMomZ(combo, FRACUNIT*2)
										combo.fuse = 15
										combo.spritexoffset = -OFFSETDIST*2
										P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
									else
										local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
										combo.state = S_FNF_COMBO_9
										P_SetObjectMomZ(combo, FRACUNIT*2)
										combo.fuse = 15
										combo.spritexoffset = -OFFSETDIST*2
										P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
									end
								end
							end
						end
					end
				end
			end
		end	
	else
		local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
		combo.state = S_FNF_COMBO_0
		P_SetObjectMomZ(combo, FRACUNIT*2)
		combo.fuse = 15
		combo.spritexoffset = -OFFSETDIST*2
		P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
	end
	if num and num >= 10
		if num < 20
			local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
			combo.state = S_FNF_COMBO_1
			P_SetObjectMomZ(combo, FRACUNIT*2)
			combo.fuse = 15
			combo.spritexoffset = -OFFSETDIST
			P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
		else
			if num < 30
				local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
				combo.state = S_FNF_COMBO_2
				P_SetObjectMomZ(combo, FRACUNIT*2)
				combo.fuse = 15
				combo.spritexoffset = -OFFSETDIST
				P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
			else
				if num < 40
					local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
					combo.state = S_FNF_COMBO_3
					P_SetObjectMomZ(combo, FRACUNIT*2)
					combo.fuse = 15
					combo.spritexoffset = -OFFSETDIST
					P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
				else
					if num < 50
						local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
						combo.state = S_FNF_COMBO_4
						P_SetObjectMomZ(combo, FRACUNIT*2)
						combo.fuse = 15
						combo.spritexoffset = -OFFSETDIST
						P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
					else
						if num < 60
							local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
							combo.state = S_FNF_COMBO_5
							P_SetObjectMomZ(combo, FRACUNIT*2)
							combo.fuse = 15
							combo.spritexoffset = -OFFSETDIST
							P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
						else
							if num < 70
								local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
								combo.state = S_FNF_COMBO_6
								P_SetObjectMomZ(combo, FRACUNIT*2)
								combo.fuse = 15
								combo.spritexoffset = -OFFSETDIST
								P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
							else
								if num < 80
									local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
									combo.state = S_FNF_COMBO_7
									P_SetObjectMomZ(combo, FRACUNIT*2)
									combo.fuse = 15
									combo.spritexoffset = -OFFSETDIST
									P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
								else
									if num < 90
										local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
										combo.state = S_FNF_COMBO_8
										P_SetObjectMomZ(combo, FRACUNIT*2)
										combo.fuse = 15
										combo.spritexoffset = -OFFSETDIST
										P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
									else
										local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
										combo.state = S_FNF_COMBO_9
										P_SetObjectMomZ(combo, FRACUNIT*2)
										combo.fuse = 15
										combo.spritexoffset = -OFFSETDIST
										P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
									end
								end
							end
						end
					end
				end
			end
		end	
	else
		local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
		combo.state = S_FNF_COMBO_0
		P_SetObjectMomZ(combo, FRACUNIT*2)
		combo.fuse = 15
		combo.spritexoffset = -OFFSETDIST
		P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
	end
	if num
		local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
		if num < 999
			combo.state = numtocombo[num%10]
		else
			combo.state = S_FNF_COMBO_9
		end	
		P_SetObjectMomZ(combo, FRACUNIT*2)
		combo.fuse = 15
		P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
	else
		local combo = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height, MT_FNF_RATING)
		combo.state = S_FNF_COMBO_0
		P_SetObjectMomZ(combo, FRACUNIT*2)
		combo.fuse = 15
		P_InstaThrust(combo, camangle - 15*ANG1, FRACUNIT)
	end
end)

rawset(_G, "FNF_Combo", function(mo, num)
	local camangle = R_PointToAngle(mo.x, mo.y)
	
	local gotox = FixedMul(DISTARW+15*FRACUNIT, cos(camangle-ANGLE_45))
	local gotoy = FixedMul(DISTARW+15*FRACUNIT, sin(camangle-ANGLE_45))
	
	local combot = P_SpawnMobjFromMobj(mo, gotox, gotoy, mo.height+FRACUNIT*15, MT_FNF_RATING)
	combot.state = S_FNF_COMBO
	P_SetObjectMomZ(combot, FRACUNIT*2)
	combot.fuse = 15
	P_InstaThrust(combot, camangle - 15*ANG1, FRACUNIT)
	
	FNF_SpriteToNum(mo, num)
end)
                                                 
rawset(_G, "FNF_PressArrow", function(mo, dir, hold) //Function for pressing arrows  
	local camangle = R_PointToAngle(mo.x, mo.y)
	for mobj in mobjs.iterate()
		if mobj and mobj.valid
		and mobj.type == MT_FNF_ARROW
		and (mobj.scale <= EARLY and mobj.scale >= LATE)
		and mobj.target == mo and dir == spectodir[mobj.dirarw]
				
				local addangle = ANGLE_90*mobj.dirarw //Use this for notes in order: 1-Left, 2-Down, 3-Right, 4-Up.
				
				local gotox = FixedMul(DISTARW, cos(camangle+addangle))
				local gotoy = FixedMul(DISTARW, sin(camangle+addangle))
				
				local arrow = P_SpawnMobjFromMobj(mo, gotox, gotoy, ((FRACUNIT*3) + (FRACUNIT/50)), MT_FNF_ARROW)
				arrow.scale = FRACUNIT
				arrow.fuse = 5
				arrow.destscale = FRACUNIT + FRACUNIT/3
				arrow.scalespeed = FRACUNIT/7
				arrow.color = mobj.color
				arrow.blendmode = AST_ADD
				arrow.flags2 = $|MF2_SPLAT
				arrow.state = dirtostate[mobj.dirarw]
				
				/*if mo.combo //Placeholder
					mo.combo = $ + 1
					FNF_Combo(mo, mo.combo)
				else
					mo.combo = 1
					FNF_Combo(mo, mo.combo)
				end*/
				if mo.combo == nil
					mo.combo = 0
				end
				
				if mo.precombo
					mo.precombo = $ + 1
					if mo.precombo >= 10
						mo.combo = $ + 1
						FNF_Combo(mo, mo.combo)
					end
				else
					mo.precombo = 1
				end
				
				if mo.player
					mo.player.sing = SINGTIME
					mo.state = singanims[spectodir[mobj.dirarw]]
					mo.sstate = singanims[spectodir[mobj.dirarw]]
				end	
				
				if (mobj.scale <= SICKE and mobj.scale >= SICKL)
					P_AddPlayerScore(mo.player, 350)
					FNF_Rating(mo, 1)
				end
				if (mobj.scale >= GOODE and mobj.scale < SICKE)//Good
				and not (mobj.scale <= SICKE and mobj.scale >= SICKL)
					P_AddPlayerScore(mo.player, 200)
					FNF_Rating(mo, 2)
				end
				if (mobj.scale <= GOODL and mobj.scale > SICKL)//Good
				and not (mobj.scale <= SICKE and mobj.scale >= SICKL)
					P_AddPlayerScore(mo.player, 200)
					FNF_Rating(mo, 2)
				end
				if (mobj.scale >= BADE and mobj.scale < GOODE)//Bad
					P_AddPlayerScore(mo.player, 100)
					FNF_Rating(mo, 3)
				end
				if (mobj.scale <= BADL and mobj.scale > GOODL)//Bad
					P_AddPlayerScore(mo.player, 100)
					FNF_Rating(mo, 3)
				end
				if (mobj.scale >= SHITE and mobj.scale < BADE)//Shit
					if mo.player.rings > 0 
						mo.player.rings = $ - 1
					else
						P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
					end
					P_StealPlayerScore(mo.player, 50)
					FNF_Rating(mo, 4)
				end
				if (mobj.scale <= SHITL and mobj.scale > BADL)//Shit
					if mo.player.rings > 0 
						mo.player.rings = $ - 1
					else
						P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
					end
					P_StealPlayerScore(mo.player, 50)
					FNF_Rating(mo, 4)
				end
				if (mobj.scale >= EARLY and mobj.scale < SHITE)//Shit
					if mo.player.rings > 0 
						mo.player.rings = $ - 1
					else
						P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
					end
					P_StealPlayerScore(mo.player, 50)
					FNF_Rating(mo, 4)
				end
				if (mobj.scale <= LATE and mobj.scale > SHITL)//Shit
					if mo.player.rings > 0 
						mo.player.rings = $ - 1
					else
						P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
					end
					P_StealPlayerScore(mo.player, 50)
					FNF_Rating(mo, 4)
				end
				
				if (mobj.scale <= SICKE and mobj.scale >= SICKL) //Sick
					local splash = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*5, MT_FNF_ARROW) //Arrow splashes
					splash.scale = FRACUNIT - FRACUNIT/3
					splash.fuse = 15
					splash.color = dirtocolor[mobj.dirarw]
					splash.flags2 = $|MF2_SPLAT
					if mobj.arwtype and mobj.arwtype == ARW_HURT
						splash.state = S_ARROW_SPLASH_C1
					elseif (mobj.arwtype and mobj.arwtype == ARW_MONITOR)
						splash.state = S_ARROW_SPLASH_D1
						splash.scale = FRACUNIT*2
						splash.spriteyoffset = -20*FRACUNIT
					else
						local sran = P_RandomRange(1, 2)
						splash.state = splashrandom[sran]
					end
				elseif (mobj.arwtype and mobj.arwtype == ARW_HURT)	//Then you can copy this if you want a special splash
					local splash = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*5, MT_FNF_ARROW) //Arrow splashes
					splash.scale = FRACUNIT - FRACUNIT/3
					splash.fuse = 15
					splash.color = dirtocolor[mobj.dirarw]
					splash.flags2 = $|MF2_SPLAT
					splash.state = S_ARROW_SPLASH_C1
				elseif (mobj.arwtype and mobj.arwtype == ARW_MONITOR)
					local splash = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*5, MT_FNF_ARROW) //Arrow splashes
					splash.scale = FRACUNIT*2
					splash.fuse = 15
					splash.color = dirtocolor[mobj.dirarw]
					splash.flags2 = $|MF2_SPLAT
					splash.state = S_ARROW_SPLASH_D1
					splash.spriteyoffset = -20*FRACUNIT
				end
				
				if mobj.arwtype
					if mobj.arwtype == ARW_HURT
						if mo.player
							mo.player.rings = 0
						end	
						P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
						if splash and splash.valid //Check it
							splash.color = SKINCOLOR_RED //Set splash color manually
							splash.state = S_ARROW_SPLASH_C1
						end	
					end
					if mobj.arwtype == ARW_BULLET
						S_StartSound(mo, sfx_bulnot)
						mo.state = dodgeanims[mobj.dirarw]
						mo.dodgetics = 15 //This is the amount of tics you are gonna be in the Dodge anim
						if mo.player
							mo.player.powers[pw_flashing] = 15 //You cant get be damaged while dodging
						end
						if splash and splash.valid
							splash.color = SKINCOLOR_YELLOW
						end	
					end
					if mobj.arwtype == ARW_RING
						S_StartSound(mo, sfx_itemup)
						if mo.player
							mo.player.rings = $ + 1
						end	
						if splash and splash.valid
							splash.color = SKINCOLOR_GOLD
						end	
					end
					if mobj.arwtype == ARW_MONITOR
						S_StartSound(mo, sfx_pop)
						if mobj.montype
							local mon = P_SpawnMobjFromMobj(mobj, mo.x+gotox, mo.y+gotoy, mo.floorz - 50*FRACUNIT, mobj.montype)
							if mon and mon.valid
								mon.fuse = 4
								mon.flags = $|MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOBLOCKMAP
								mon.flags2 = $|MF2_DONTDRAW
								S_StopSound(mon)
								P_DamageMobj(mon, mo, mo, DMG_INSTAKILL)
								S_StopSound(mon)
							end	
						end
					end
					if mobj.arwtype == ARW_ATTACK
						S_StartSound(mo, sfx_spkdth)
						local targ = P_LookForEnemies(mo.player, false, true)
						if targ and targ.valid
							local arrow = P_SpawnPointMissile(mo, targ.x, targ.y, targ.z, MT_DEMONFIRE, mo.x+gotox, mo.y+gotoy, mo.z+FRACUNIT*7)
							arrow.flags2 = $|MF2_SPLAT
							arrow.state = dirtostate[mobj.dirarw]
							arrow.tracer = mo
							arrow.color = dirtocolor[mobj.dirarw]
							if dir == LEFT
								arrow.rollangle = -ANGLE_90
							elseif dir == DOWN
								arrow.rollangle = -ANGLE_180
							elseif dir == RIGHT
								arrow.rollangle = ANGLE_90
							end
							mo.state = attackanims[mobj.dirarw]
							mo.attacktics = ATTACKTIME 
						else
							if mo.player.rings > 0 
								mo.player.rings = $ - 1
							else
								P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
							end
							mo.player.miss = MISSTIME
							mo.state = missanims[spectodir[mobj.dirarw]]
							mo.mstate = missanims[spectodir[mobj.dirarw]]
						end
						if splash and splash.valid
							splash.color = SKINCOLOR_WHITE
						end
					end
					if mobj.arwtype == ARW_CUSTOM //Add properties for pressing it
						mo.color = P_RandomRange(1, #skincolors-1)
					end
					mobj.ded = true
					P_KillMobj(mobj, nil, nil)
				end
		end	
	end	
end)

rawset(_G, "FNF_SpawnInputs", function(mo, dir) //Input Arrows
	local camangle = R_PointToAngle(mo.x, mo.y)
		for i = 1, 4
			local addangle = ANGLE_90*i
			
			local gotox = FixedMul(DISTARW, cos(camangle+addangle))
			local gotoy = FixedMul(DISTARW, sin(camangle+addangle))
			
			local arrow = P_SpawnMobjFromMobj(mo, gotox, gotoy, FRACUNIT*3, MT_FNF_ARROW)
			arrow.scale = FRACUNIT
			arrow.fuse = 2
			arrow.color = SKINCOLOR_GREY
			arrow.flags2 = $|MF2_SPLAT
			arrow.state = dirtostate[i]
			arrow.frame = $|FF_TRANS20
			if P_MobjFlip(mo) == 1
				arrow.renderflags = $ & ~RF_VERTICALFLIP
			else
				arrow.renderflags = $|RF_VERTICALFLIP
			end
			if dir //Make arrows smaller when you press a note or dont (You can delete this if you dont need it)
				if dir == 1 and i == 1
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				elseif dir == 2 and i == 2
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				elseif dir == 4 and i == 4
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				elseif dir == 3 and i == 3
					arrow.scale = FRACUNIT - FRACUNIT/5
					arrow.color = SKINCOLOR_SILVER
				end
			end
			/*if dir 
				for mobj in mobjs.iterate() //And make arrows bigger and light up if you hit a note
					if mobj and mobj.valid
					and mobj.type == MT_FNF_ARROW
					and (mobj.scale <= EARLY and mobj.scale >= LATE)
					and mobj.dirarw and mobj.target == mo
					and (mobj.dirarw == dir or dir == mobj.dirarw)
					and (mobj.dirarw == i and dir == i)
						arrow.scale = FRACUNIT + FRACUNIT/5
						arrow.blendmode = AST_ADD
						arrow.color = dirtocolor[i]
					else
						arrow.scale = FRACUNIT - FRACUNIT/5
						arrow.color = SKINCOLOR_SILVER
					end
				end	
			end*/
		end	
end)

freeslot("sfx_miss1", "sfx_miss2", "sfx_miss3") //Miss Sounds

rawset(_G, "FNF_NoteCheck", function(mo) //Arrow checks (for stuff like misses)
	local camangle = R_PointToAngle(mo.x, mo.y)
	if mo.player 
		local misssound = P_RandomRange(1, 3)
		local misssounds = {sfx_miss1,sfx_miss2,sfx_miss3} //There are the miss sounds, if you add more sounds it will play a random one out of these
		for mobj in mobjs.iterate()
			if mobj and mobj.valid
			and mobj.type == MT_FNF_ARROW
			and mobj.dirarw and mobj.target == mo
			and not mobj.ded
				if mobj.scale < LATE
				and mobj.scale >= LATE-FRACUNIT/15
					if mobj.arwtype == ARW_BULLET //If you miss you lose rings or die
						S_StartSound(mo, sfx_bulnot)
						if mo.player.rings >= 10
							mo.player.rings = $ - 10
						else
							P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
							mo.shootdeathanim = true //Funni death anim
							mo.shootroll = P_RandomRange(-30, 30)
							P_SetObjectMomZ(mo, 5*FRACUNIT)
							if mobj.dirarw == BLEFT
								P_InstaThrust(mo, mo.angle + ANGLE_90, 30*FRACUNIT)
							end
							if mobj.dirarw == BDOWN
								P_InstaThrust(mo, mo.angle - ANGLE_180, 30*FRACUNIT)
							end
							if mobj.dirarw == BUP
								P_InstaThrust(mo, mo.angle, 30*FRACUNIT)
							end
							if mobj.dirarw == BRIGHT
								P_InstaThrust(mo, mo.angle - ANGLE_90, 30*FRACUNIT)
							end
						end 
						
						local exp = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_EXPLODE) 
						exp.scale = FRACUNIT/3 //Smol Bullet explosion
					end 
					if mobj.arwtype != ARW_HURT 
					and mobj.arwtype != ARW_BULLET //This exists because bullet and miss sound doesnt work good
					and mobj.arwtype != ARW_CUSTOM
					and mobj.arwtype != ARW_RING
					and mobj.arwtype != ARW_MONITOR
					and mobj.arwtype != ARW_ATTACK
						if mo.player.rings > 0 
							mo.player.rings = $ - 1
						else
							P_DamageMobj(mo, nil, nil, DMG_INSTAKILL)
						end
						if mo.precombo
							mo.precombo = 1
						end
						if mo.combo
							mo.combo = 0
							FNF_Combo(mo, mo.combo)
						end
						P_StealPlayerScore(mo.player, 50)
						FNF_Rating(mo, 4)
						mo.player.miss = MISSTIME //Miss timer just idk why (maybe you need it)
						if mobj.arwdir
							mo.state = missanims[spectodir[mobj.arwdir]]
							mo.mstate = missanims[spectodir[mobj.arwdir]]
						end	
					end	
					if mobj.arwtype == ARW_CUSTOM //Add properties for missing your arrow
						S_StartSound(mo, sfx_itemup) //Edit the miss thing above if it has a penality for missing it or not
						mo.player.rings = $ + P_RandomRange(2, 15)
						mo.customvar = 15
					end 
					mobj.target = nil
				end
			end	
		end	
		if mo.player.miss
			mo.player.miss = $ - 1
			if mo.player.miss >= 14
				S_StartSound(mo, misssounds[misssound]) //Miss sound
			end
			if mo.mstate
				if mo.state != mo.mstate
					mo.state = mo.mstate
				end
			end	
			if mo.player.miss == 1
				for i = 1, 50
					if mo.state == missanims[i]
						mo.player.miss = 0
						mo.state = S_PLAY_STND
					end
				end
			end	
		end
		if mo.player.sing
			mo.player.sing = $ - 1
			/*if mo.player.sing >= 14
				S_StartSound(mo, singsounds[singsound]) //Miss sound
			end*/
			if mo.sstate
				if mo.state != mo.sstate
					mo.state = mo.sstate
				end
			end	
			if mo.player.sing == 1
				for i = 1, 50
					if mo.state == singanims[i]
						mo.player.sing = 0
						mo.state = S_PLAY_STND
					end
				end
			end	
		end
		/*if mo.player.holdleft
			mo.player.holdleft = $ - 1
		end
		if mo.player.holddown
			mo.player.holddown = $ - 1
		end
		if mo.player.holdup
			mo.player.holdup = $ - 1
		end
		if mo.player.holdright
			mo.player.holdright = $ - 1
		end*/
	end	
end)

addHook("ThinkFrame", do //Make player transparent so you can see notes clearer
	for mo in mobjs.iterate()
		if mo and mo.valid and mo.player
			if mo.shootdeathanim and mo.shootroll and mo.player.playerstate == PST_DEAD //Speeeen
				mo.rollangle = $ + mo.shootroll*ANG1
				if P_IsObjectOnGround(mo)
					if mo.rollangle >= 0
						mo.rollangle = ANGLE_90
					else
						mo.rollangle = -ANGLE_90
					end	
					if R_PointToDist2(0, 0, mo.momx, mo.momy) >= 15*FRACUNIT
						local ranx = FixedMul(P_RandomRange(-mo.height/FRACUNIT, mo.height/FRACUNIT)*FRACUNIT, cos(P_RandomRange(0, 360)*ANG1))
						local rany = FixedMul(P_RandomRange(-mo.height/FRACUNIT, mo.height/FRACUNIT)*FRACUNIT, sin(P_RandomRange(0, 360)*ANG1))
						local dust = P_SpawnMobjFromMobj(mo, ranx, rany, FRACUNIT, MT_DUST)
					end
				end
			end
			if mo.customvar //And maybe something more
				mo.customvar = $ - 1
				mo.color = P_RandomRange(1, #skincolors-1)
				if mo.customvar == 1
					mo.customvar = 0
					mo.color = mo.player.skincolor
				end
			end
			if mo.dodgetics //Dodge anim if you have one
				mo.dodgetics = $ - 1 //Just delete this if you dont need it
				if mo.dodgetics == 1
					mo.dodgetics = 0
					for i = 1, 50
						if mo.state == dodgeanims[i] //Revert back to standing when done dodging
							mo.state = S_PLAY_STND
						end
					end
				end	
			end
			if mo.attacktics //Attack anim if you have one
				mo.attacktics = $ - 1 //Just delete this if you dont need it
				if mo.attacktics == 1
					mo.attacktics = 0
					for i = 1, 50
						if mo.state == attackanims[i] //Revert back to standing when done dodging
							mo.state = S_PLAY_STND
						end
					end
				end	
			end
			if displayplayer == mo.player
				if mo.player.fnf
					mo.frame = $|FF_TRANS70
					mo.transgender = true
				else
					if mo.transgender
						mo.transgender = false
						mo.frame = $ & ~FF_TRANS70
					end
				end
			end	
		end
	end
end)

addHook("MobjDeath", function(mo) //Reset FNF variables when dying and respawning
	if mo.player
		if mo.player.fnf
			mo.player.fnf = false
		end
		mo.player.time = -1
		mo.player.miss = 0
	end
end, MT_PLAYER)

addHook("PlayerSpawn", function(player)
	if player
		if player.fnf
			player.fnf = false
		end
		player.time = -1
		player.miss = 0
	end
end)

local chart = { //Chart Stuff Here
HLEFT,0, //Special notes check
BDOWN,0,
CUP,0, //And finishing touch... add it to your chart!
RIGHT,0,
RUP,0,
ADOWN,0,
MLEFT,0,
MRIGHT,0,
0,0,0,0,0,
LEFT, //notes spawns every 20 tics (player.time%20)
0,
RIGHT,
0,
0,
LEFT,
0,
RIGHT,
0, //This makes a pause beetween notes
0,
0,
UP,
0,
DOWN,0,0,
UP,0,
DOWN,0,0,0,
LEFT,0,
UP,0,
DOWN,0,
RIGHT,0,0,0,
DOWN,0,
DOWN,0,
UP,0,0,
DOWN,0,
DOWN,0,
RIGHT,0,0,0,
DOWN,
UP,
RIGHT,
UP,0,0,
RIGHT,0,0,
RIGHT,0,
RIGHT,0,
DOWN,0,
LEFT,0,
DOWN,0,
UP,0,
RIGHT,0,
LEFT,0,
UP,0,
DOWN, //Now long notes are actually possible because new input system
DOWN, //But they are still like this...
DOWN,0,0,0,0,
0,0,
LEFT,
DOWN,
UP,
RIGHT,
UP,
DOWN,
LEFT,
DOWN,
UP,
RIGHT,
UP,
RIGHT,
UP,
RIGHT,
DOWN,
LEFT,0,0,0,0,0} //I tried to chart the Tutorial from the Original. Should be accurate but the timings are a bit off.

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if player.fnf
			if (leveltime%20) == 0 //I recommend this stuff below for FNF stuff for now.
				player.time = $ + 1
				player.use = true
			else
				player.use = false
			end	
			FNF_NoteCheck(player.mo) //Run every tic
			if chart and chart[player.time%#chart+1]
			and player.use //But it wont stop the "FNF mode"
				FNF_SpawnArrow(player.mo, chart[player.time%#chart+1], FRACUNIT/35) //This thing spawns notes
			end
			if chart and (player.time >= #chart-1) //A reward for completing the song
				player.fnf = false //Also stops the song
				player.time = -1 //and resets it
				player.powers[pw_invulnerability] = TICRATE*60
			end
			if player.cmd.sidemove <= -25 //Inputs (if you dont like it you can change it)
				if not player.left
					FNF_PressArrow(player.mo, 1)
				end	
				FNF_SpawnInputs(player.mo, 1)
				player.left = true
			else
				if player.left
					player.holdleft = 0
				end
				player.left = false
			end
			if player.cmd.forwardmove <= -25
				if not player.down
					FNF_PressArrow(player.mo, 2)
				end	
				FNF_SpawnInputs(player.mo, 2)
				player.down = true
			else
				if player.down
					player.holddown = 0
				end
				player.down = false
			end
			if player.cmd.forwardmove >= 25
				if not player.up
					FNF_PressArrow(player.mo, 4)
				end	
				FNF_SpawnInputs(player.mo, 4)
				player.up = true
			else
				if player.up
					player.holdup = 0
				end
				player.up = false
			end
			if player.cmd.sidemove >= 25
				if not player.right
					FNF_PressArrow(player.mo, 3)
				end	
				FNF_SpawnInputs(player.mo, 3)
				player.right = true
			else
				if player.right
					player.holdright = 0
				end
				player.right = false
			end
			if not (player.cmd.sidemove or player.cmd.forwardmove)
				FNF_SpawnInputs(player.mo)
			end
		end
		if player.cmd.buttons & BT_CUSTOM3 //Placeholders for activating "FNF mode"
			if not player.c3
				player.fnf = true
				player.time = -1
			end
			player.c3 = true
		else
			player.c3 = false
		end
		/*if player.cmd.buttons & BT_TOSSFLAG
			if not player.ts
				player.fnf = false
				player.time = -1
			end
			player.ts = true
		else
			player.ts = false
		end*/
	end
end)